c
c SLOW CONTROL PC DATA
c
c *** must be preceeded by hec_hvpar.inc
c
c --- High Voltage module for CALORIMETER:
c
c hv_cal_hv(i,j)
c      high voltage values (V) module i, channel j
c hv_cal_i(i,j) 
c      current values (muA) module i, channel j
c
c --- High Voltage module for PM:
c
c hv_pm_hv(i,j)
c      high voltage values (V) module i, channel j
c hv_pm_i(i,j)   
c      current values (muA) module i, channel j
c
c --- High Voltage module for MWPC:
c
c hv_mwpc_hv(i,j)
c      high voltage value (V) module i, channel j
c hv_mwpc_i(i,j) 
c      current values (muA) module i, channel j
c
c --- Pressure (mbar) of LAr vapor 
c
c cryo_press
c
c --- Temperature (K) in Cryostat (only 7 out of 8 points filled)
c
c cryo_temp(i) 
c     temperature value
c
c
      integer nval_temp_max
      parameter (nval_temp_max = 8)
c
      real hv_cal_i( 0:nmodhv_cal_max-1 , nchhv_cal_max )
      real hv_cal_hv( 0:nmodhv_cal_max-1, nchhv_cal_max)
      real hv_pm_i( 0:nmodhv_pm_max-1 , nchhv_pm_max)
      real hv_pm_hv( 0:nmodhv_pm_max-1 , nchhv_pm_max)
      real hv_mwpc_i( 0:nmodhv_mwpc_max-1 , nchhv_mwpc_max)
      real hv_mwpc_hv( 0:nmodhv_mwpc_max-1 , nchhv_mwpc_max )
      real cryo_press
      real cryo_temp(nval_temp_max)

      common /ssspcslow/hv_cal_i,hv_cal_hv,
     +	                hv_pm_i,hv_pm_hv,
     +	                hv_mwpc_i,hv_mwpc_hv,
     +                  cryo_press,cryo_temp







