      subroutine hec_cal
c
c calibration package
c pre requires:
c     pedestal package:  uses preferred pedestals
c     max finding package compatible with calibration file used
c
c initialises calibration package by calling for 
c calibration file to be read in
c
      implicit none
c
      include'hec_par.inc'      !shared parameters
      include'hec_cal.inc'      !calibrated energies common
      include'hec_cal_coef.inc' !calibration coefficients
      include'hec_datacard.inc' !datacard values
c
      integer ic
c
c reset calibration coefficients array
c
      call vzero(hec_cal_coef, 5*i_adc_dim)
      do ic = 1, i_adc_dim
        ic_has_calib(ic) = .false.
      enddo
c
      if (io_cal(1) .gt. 0) then
c
c read calibration
c
        call hec_cal_read
c
c print the calibration coefficients if requested
c
        if (io_cal(3) .ne. 0) call hec_cal_print
      endif
c
      end
